--
-- manschetteKotteBefueller
-- Specialization for manschette
--
-- @author upsidedown
-- update Bayerbua
-- @date  13.07.2013


manschetteKotteBefueller = {};

function manschetteKotteBefueller.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations);
end;

function manschetteKotteBefueller:load(xmlFile)
	self.manschetteKotteBefuellerNode1 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.manschetteKotteBefueller#index1"));
	self.manschetteKotteBefuellerNode2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.manschetteKotteBefueller#index2"));
	self.manschetteKotteBefuellerIsFieldcontainer = Utils.getNoNil(getXMLBool(self.xmlFile, "vehicle.manschette#isFieldcontainer"), false);	
	self.fillerArmKotteBefuellerKotteBefuellerInRange = false;
	self.manschetteKotteBefuellerWasMoved = false;
	self.manschetteKotteBefuellerDrawLine = false;
	self.manschetteKotteBefuellerDistance = 30
	
	local tx, ty, tz = getTranslation(self.manschetteKotteBefuellerNode1);
	self.manschetteKotteBefuellerYmax1 = ty;
	tx, ty, tz = getTranslation(self.manschetteKotteBefuellerNode2);
	self.manschetteKotteBefuellerYmax2 = ty;
	self.manschetteKotteBefuellerIsAttached = false	
end;

function manschetteKotteBefueller:update(dt)
	if self.manschetteKotteBefuellerIsAttached == true or self.manschetteKotteBefuellerIsFieldcontainer == true then
		if self.manschetteKotteBefuellerDrawLine then
			local dx, dy, dz = localDirectionToWorld(self.rootNode, 0, 0, 0);
			local length = Utils.vector2Length(dx,dz);
			local dx = dx/length;
			local dz = dz/length;
			
			
			local ax,ay,az = getTranslation(self.manschetteKotteBefuellerNode1);
						
			local x_offset = 3.10; --in later version get this number from 'arm'-vehicle
			local x,y,z = localToWorld(self.manschetteKotteBefuellerNode1,ax+x_offset,ay,az);-- start point at the side of the vehicle
			
			local r = 0;
			local g = 0;
			local b = 1;
			local ploty = 0;
			local plotx = 0;
			local plotz = 0;
			
--			for k = -15,25,2 do
--				plotx = x + k*dx;
--				plotz = z + k*dz;
--				ploty = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, plotx, py, plotz) + .2;
--				plotx2 = x + (k+1)*dx;
--				plotz2 = z + (k+1)*dz;
--				ploty2 = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, plotx2, py, plotz2) + .2;
		
--				drawDebugLine(plotx, ploty, plotz, r, g, b, plotx2, ploty2, plotz2, r, g, b);				
--			end;
			
			if self.fillerArmKotteBefueller.vehicle:getIsActiveForInput(false) then --z distance calculation				
				local vx, vy, vz = getWorldTranslation(self.fillerArmKotteBefueller.fillerArmKotteBefuellerNode);
				local fx, fy, fz = worldToLocal(self.manschetteKotteBefuellerNode1,vx,vy,vz);
				if math.abs(fz) < 0.01 then -- prevent +/- flickering
					fz = 0;
				end;
		
				local dist = math.sqrt(math.pow(fx,2)+math.pow(fy,2)+math.pow(fz,2))
				self.manschetteKotteBefuellerDistance = dist	
				--g_currentMission.fruitSymbolY g_currentMission.fruitSymbolSize
				
				setTextAlignment(RenderText.ALIGN_RIGHT); 
				setTextBold(true);
				setTextColor(math.min(.8*math.abs(fz/1.5),1),.8,0,1);
				renderText(0.998,0.22,0.012, string.format("%2.2f m", dist));
				--renderText(.402+ 0.085,0.85238 + 0.010,0.022, string.format("proof of principle: Einweisung Befuellarm: %2.2f m", -fz));
				setTextAlignment(RenderText.ALIGN_LEFT); -- (hopefully) prevent influence on scripts without explicit format coding
				setTextBold(false);
				setTextColor(1,1,1,1);
			end
		end;
	end;
end;

function manschetteKotteBefueller:updateTick(dt)
	if self.manschetteKotteBefuellerIsAttached == true or self.manschetteKotteBefuellerIsFieldcontainer == true then
		self.fillerArmKotteBefuellerInRange = false; 
		local nearestDistance = 30;
		local px, py, pz = getWorldTranslation(self.manschetteKotteBefuellerNode1);
		for i=1, table.getn(g_currentMission.attachables) do
			if g_currentMission.attachables[i].fillerArmKotteBefuellerNode ~= nil then 
				local vx, vy, vz = getWorldTranslation(g_currentMission.attachables[i].fillerArmKotteBefuellerNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					--self.fillerArmKotteBefuellerInRange = true;
					nearestDistance = distance;
					self.fillerArmKotteBefueller = {};
					self.fillerArmKotteBefueller.vehicle = g_currentMission.attachables[i];
					self.fillerArmKotteBefueller.fillerArmKotteBefuellerNode = g_currentMission.attachables[i].fillerArmKotteBefuellerNode;
				end;
			end;
		end;

		for i=1, table.getn(g_currentMission.steerables) do
			if g_currentMission.steerables[i].fillerArmKotteBefuellerNode ~= nil then 
				local vx, vy, vz = getWorldTranslation(g_currentMission.steerables[i].fillerArmKotteBefuellerNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					--self.fillerArmKotteBefuellerInRange = true;
					nearestDistance = distance;
					self.fillerArmKotteBefueller = {};
					self.fillerArmKotteBefueller.vehicle = g_currentMission.steerables[i];
					self.fillerArmKotteBefueller.fillerArmKotteBefuellerNode = g_currentMission.steerables[i].fillerArmKotteBefuellerNode;
				end;
			end;	
		end;
		
		if nearestDistance < 0.2 then			
			self.fillerArmKotteBefuellerInRange = true;
		end;
		
		if self.fillerArmKotteBefuellerInRange then --animation manschetteKotteBefueller			
			local vx, vy, vz = getWorldTranslation(self.fillerArmKotteBefueller.fillerArmKotteBefuellerNode);
			
			local x,y,z = worldToLocal(self.manschetteKotteBefuellerNode1,vx, vy, vz);
			local rx,ry,rz = getRotation(self.manschetteKotteBefuellerNode1);
			
			local maxRot = 0.6;
			rx = Utils.clamp(rx + 2.0*Utils.clamp(z,-.05,.05),-maxRot,maxRot);
			rz = Utils.clamp(rz - 2.0*Utils.clamp(x,-.05,.05),-maxRot,maxRot);
			setRotation(self.manschetteKotteBefuellerNode2,.3*rx,0,.3*rz);
			setRotation(self.manschetteKotteBefuellerNode1,rx,0,rz);
			
			local startPushing = 0.075;
			
				local maxTrans = 0.1;				
				local tx, ty, tz = getTranslation(self.manschetteKotteBefuellerNode1)
				local tx2, ty2, tz2 = getTranslation(self.manschetteKotteBefuellerNode2)
				
				local dty = (y-startPushing)*0.01*dt
				
				ty = Utils.clamp(ty+dty,self.manschetteKotteBefuellerYmax1-maxTrans,self.manschetteKotteBefuellerYmax1);
				ty2 = Utils.clamp(ty2+1.5*dty,self.manschetteKotteBefuellerYmax2-maxTrans,self.manschetteKotteBefuellerYmax2);
				
				
				setTranslation(self.manschetteKotteBefuellerNode1,tx, ty, tz)
				setTranslation(self.manschetteKotteBefuellerNode2,tx2, ty2, tz2)
				
			--print(ty)
			self.manschetteKotteBefuellerWasMoved	= true;
		elseif self.manschetteKotteBefuellerWasMoved then --return to neutral position
			local resetFactor = 1-dt*0.002;
			local rx,ry,rz = getRotation(self.manschetteKotteBefuellerNode1);
			rx = resetFactor * rx;
			rz = resetFactor * rz;
			local rotDone = false;
			
			if math.abs(rx) < .001 and math.abs(rz) < 0.001 then
				rx = 0;
				rz = 0;
				rotDone = true;
			end;
			setRotation(self.manschetteKotteBefuellerNode2,0.3*rx,0,0.3*rz);
			setRotation(self.manschetteKotteBefuellerNode1,rx,0,rz);
			
			
			local tx, ty, tz = getTranslation(self.manschetteKotteBefuellerNode1)
			local dty = 0.003*dt*(self.manschetteKotteBefuellerYmax1 - ty);
			setTranslation(self.manschetteKotteBefuellerNode1,tx, ty+dty, tz)
			
			tx, ty, tz = getTranslation(self.manschetteKotteBefuellerNode2)
			dty = 0.003*dt*(self.manschetteKotteBefuellerYmax2 - ty);
			setTranslation(self.manschetteKotteBefuellerNode2,tx, ty+dty, tz)
			--
			
			if rotDone and math.abs(self.manschetteKotteBefuellerYmax2 - ty) < 0.01 then
				self.manschetteKotteBefuellerWasMoved = false;
			end;
			
		end;
		
		if nearestDistance < 25 then
			self.manschetteKotteBefuellerDrawLine = true;
		else
			self.manschetteKotteBefuellerDrawLine = false;
		end	
	end	
end;

--function manschetteKotteBefueller:fertilizerInRange(dt)
--end;

function manschetteKotteBefueller:delete()
end;

function manschetteKotteBefueller:mouseEvent(posX, posY, isDown, isUp, button)
end;

function manschetteKotteBefueller:keyEvent(unicode, sym, modifier, isDown)
end;

function manschetteKotteBefueller:draw()
end;

function manschetteKotteBefueller:onAttach()
	self.manschetteKotteBefuellerIsAttached = true
end; 	

function manschetteKotteBefueller:onDetach()
	self.manschetteKotteBefuellerIsAttached = false
end;